#include <stdlib.h>
#include <gtree.h>


gtree_t *
__gtree_new (gtree_t * root)
{

  root->nchilds = 0;
  root->childs = NULL;
  root->sibling = NULL;

  return root;
}

gtree_t *
__gtree_append (gtree_t * root, gtree_t * child)
{

  root->nchilds++;
  root->childs =
    (gtree_t **) realloc (root->childs, sizeof (gtree_t *) * root->nchilds);
  root->childs[root->nchilds - 1] = child;

  return child;

}

gtree_t *
__gtree_insert (gtree_t * root, gtree_t * sibling)
{

  root->sibling = sibling;

  return sibling;

}


void
gtree_walk (gtree_t * root, void (*algorithm) (gtree_t *))
{

  if (root == NULL)
    return;

  algorithm (root);

  gtree_walk (root->sibling, algorithm);

  int i;
  for (i = 0; i < root->nchilds; i++)
    gtree_walk (root->childs[i], algorithm);

  return;
}

void
gtree_postorder (gtree_t * root, void (*algorithm) (gtree_t *))
{

  if (root == NULL)
    return;

  gtree_postorder (root->sibling, algorithm);

  int i;
  for (i = 0; i < root->nchilds; i++)
    gtree_postorder (root->childs[i], algorithm);

  algorithm (root);

  return;
}


void
gtree_transverse (gtree_t * root, int depth,
		  void (*algorithm) (gtree_t *, int))
{

  if (root == NULL)
    return;

  algorithm (root, depth);

  gtree_transverse (root->sibling, depth, algorithm);

  int i;
  for (i = 0; i < root->nchilds; i++)
    gtree_transverse (root->childs[i], depth + 1, algorithm);

  return;
}
