#ifndef GTREE_H
#define GTREE_H

typedef struct gtree{
  struct gtree *sibling;
  struct gtree **childs;
  int nchilds;
}gtree_t;

#define GTREE( tree ) (( gtree_t * ) tree)

gtree_t * __gtree_new();
gtree_t * __gtree_insert( gtree_t * root, gtree_t *sibling );
gtree_t * __gtree_append( gtree_t * root, gtree_t *child );
void gtree_walk( gtree_t * root, void (* algorithm ) ( gtree_t * ) );
void gtree_transverse( gtree_t * root, int depth, void (* algorithm ) ( gtree_t *, int ) );
void gtree_postorder( gtree_t * root, void (* algorithm ) ( gtree_t * ));

#define gtree_new( type )                                                       \
           ({                                                                   \
             type *_n = malloc( sizeof( type ) );                               \
             memset( _n, 0, sizeof( type ) );                                   \
	     (type*)__gtree_new( GTREE( _n) );                                  \
	   })                                                                   \


#define gtree_insert( tree, type )                                              \
           ({                                                                   \
             type *_n = malloc( sizeof( type ) );                               \
             memset( _n, 0, sizeof( type ) );                                   \
	     (type*)__gtree_insert( GTREE(tree), GTREE( _n) );                  \
	   })                                                                   \

#define gtree_append( tree, type )                                              \
           ({                                                                   \
             type *_n = malloc( sizeof( type ) );                               \
             memset( _n, 0, sizeof( type ) );                                   \
	     (type*)__gtree_append( GTREE(tree), GTREE( _n) );                  \
	   })                                                                   \

#endif
