#ifndef INSTANCE_H
#define INSTANCE_H

#include <gvc.h>
#include <assert.h>
#include <malloc.h>
#define GNU_SOURCE
#include <string.h>
#include <linkedlist.h>
#include <var.h>
#include <module.h>

typedef struct portmap
{
  char *port;
  char *wire;
} portmap_t;

typedef struct portmapn
{
  listnode_t node;
  portmap_t map;
} portmapn_t;

typedef struct instance
{
  char *name;
  char *module;
  int set;
  linkedlist_t *mapping;
} instance_t;

typedef struct instancen
{
  listnode_t node;
  instance_t *instance;
} instancen_t;

#define instance_str( i ) __instance_str( #i, i )

char *__instance_str (char *name, instance_t * i);
inline instance_t *instance_new (char *name, char *module);
inline void instance_free (instance_t * i);


#endif
