#include <parse.h>


int
parse (int argc, char **argv)
{

  return keystone (argc, argv);

}

int
keystone (int argc, char **argv)
{
  int pipe_stdout[2];
  int pipe_stderr[2];
  char buf[60];

  int result = 1;

  pipe (pipe_stdout);
  pipe (pipe_stderr);

  char *keystone_path = "/usr/local/bin/key";

  argv = (char **) realloc (argv, (argc + 5) * sizeof (char *));
  argv[0] = keystone_path;
  argv[argc + 0] = "--fast2dot";
  argv[argc + 1] = "--verbose";
  argv[argc + 2] = "-I";
  //argv[ argc + 3 ] = "../include";
  argv[argc + 3] = GSC_INCLUDE;
  argv[argc + 4] = NULL;

  argc += 4;

  if (!fork ())
    {
      close (1);
      dup (pipe_stdout[1]);
      close (2);
      dup (pipe_stderr[1]);
      execv (keystone_path, argv);
      exit (0);
    }
  else
    {

      fd_set rfds;
      struct timeval tv;
      int retval;
      FD_ZERO (&rfds);
      FD_SET (pipe_stdout[0], &rfds);
      FD_SET (pipe_stderr[0], &rfds);
      tv.tv_sec = 5;
      tv.tv_usec = 0;

      int max =
	pipe_stdout[0] > pipe_stderr[0] ? pipe_stdout[0] : pipe_stderr[0];
      retval = select (max + 1, &rfds, NULL, NULL, NULL);

      if (retval == -1)
	perror ("select() error");
      else if (retval)
	{
	}
      else
	printf ("timeout!\n");

      if (FD_ISSET (pipe_stdout[0], &rfds))
	{
	  int n = read (pipe_stdout[0], buf, sizeof (buf));
	  //buf[ n ] = '\0';
	  //printf( "parent: got from stdout [%s]\n", buf );
	}

      if (FD_ISSET (pipe_stderr[0], &rfds))
	{
	  char errors[4 * 1024];
	  int n = read (pipe_stderr[0], errors, sizeof (errors));
	  //errors[ n ] = '\0';
	  //printf( "parent: got from stderr [%s]\n", errors );
	  fprintf (stderr, "%s", errors);
	  result = 0;
	}
      wait (NULL);
    }

  return result;

}
