#ifndef AVALON_MP3_H
#define AVALON_MP3_H
#include "systemc.h"
#define FIFOSIZE_LOG2 7
#define FIFOSIZE (1<<FIFOSIZE_LOG2)

SC_MODULE (avalon_mp3)
{

  sc_in<bool> clk;
  sc_in<bool> reset_n;

  // INPUT FROM AVALON BUS
  sc_in<sc_uint<3> > address;
  sc_in<bool> read;
  sc_out<sc_uint<32> > readdata;
  sc_in<bool> write;
  sc_in<sc_uint<32> > writedata;

  sc_out<bool> waitrequest;
  sc_in<bool> chipselect;


/*
  // SAMPLE OUT TO DAC
  sc_out<sc_uint<1> >   MAddr;
  sc_out<sc_uint<3> >   MCmd;
  sc_out<sc_uint<32> >  MData;
  sc_in<bool>          SCmdAccept;
  sc_in<sc_uint<8> >   SData;
  sc_in<sc_uint<2> >   SResp;
*/

  sc_uint<32> fifo_block[FIFOSIZE];
  sc_uint<32> fifo_data[FIFOSIZE];

  sc_signal<bool > fifo_write_block;
  sc_signal<sc_uint<FIFOSIZE_LOG2> > fifo_begin;
  sc_signal<sc_uint<FIFOSIZE_LOG2> > fifo_end;

  void prc_avalon();
  
  SC_CTOR (avalon_mp3){

    SC_METHOD(prc_avalon);
    sensitive_pos << clk;

  }
};

#endif
