#include "imdctwindow.h"
                       
//#define DEBUG_MODE

void imdctwindow::fsm(){

  if (Reset_n == 0){

    // Inicializacao das variaveis
    in_ready = 0;
    out_trans = 0;
      j=0;
    buf_ram_we = 0;
    buf_ram_addr = 0;
    buf_ram_in = 0;
    buf_rom_addr = 0;
    mul_a = 0;
    mul_b = 0;

    wait = 0;
    bt2 = 0;

    read_on_ram = 0;
    data_ant = 0;
    i=0;
    data_out = 0;
    block_type = in_block_type.read();
    out_nch = in_nch.read();
    nch = in_nch.read();

    next_state = write_state;
    state = read_state;
  }
  else switch (state) {

    case read_state:
      out_trans = 0;
      in_ready = 1; // Pronto para ler

      wait = 0;
      bt2 = 0;

      buf_ram_we = 0;
      mul_c_ant = 0;
      mul_a = data_in.read();
      data_ant = data_in.read();
      read_on_ram = 0;

      // Leitura do numero de canais "in_nch" e block type. Repasse nch para saida
      if (i.read() == 0 && in_trans.read() == 1) {
        nch = in_nch.read();
        out_nch = in_nch.read();
        block_type = in_block_type.read();
	     j=1+j.read();
	//     printf("DUVim%d ", (int)j.read());
      }
      else {
        out_nch = nch.read();
        nch = nch.read();
        block_type = block_type.read();
      }
      // Verifica se os dados de entrada sao validos
      if (in_trans.read() == 1) {
        switch (in_block_type.read()) {
          case 0:
            data_out = data_out.read(); //
            buf_rom_addr = i.read();
            buf_ram_addr = buf_ram_addr.read(); //
            state = buf_mult;
            next_state = write_state;
            if (i.read() != 35) i = i.read() + 1;
            else i = 0;
            break;

          case 1:
            if (i.read() < 18) {
              data_out = data_out.read(); //
              buf_rom_addr = i.read();
              state = buf_mult;
            }
            else if (i.read() >= 18 && i.read() < 24) {
              data_out = data_in;
              buf_rom_addr = buf_rom_addr.read(); //
              wait = 1;
              state = write_state;
            }
            else if (i.read() >= 24 && i.read() < 30) {
              data_out = data_out.read(); //
              buf_rom_addr = i.read() - 18+36;
              state = buf_mult;
            }
            else if (i.read() >= 30 && i.read() < 36 ){
              data_out = 0; 
              buf_rom_addr = buf_rom_addr.read(); //
              wait = 1;
              state = write_state;
            }
            buf_ram_addr = buf_ram_addr.read(); //       
            next_state = write_state;
            if (i.read() != 35) i = i.read() + 1;
            else i = 0;
            break;

          case 3:
            if (i.read() < 6) {
              data_out = 0;
              buf_rom_addr = buf_rom_addr.read(); // 
              wait = 1;
              state = write_state;
            }
            else if (i.read() >= 6 && i.read() < 12) {
              data_out = data_out.read(); //
              buf_rom_addr = i.read() - 6 + 36;
              state = buf_mult;
            }
            else if (i.read() >= 12 && i.read() < 18) {  
              data_out = data_in; 
              buf_rom_addr = buf_rom_addr.read(); //
              wait = 1;
              state = write_state;
            }
            else if (i.read() >= 18 && i.read() < 36) {
              data_out = data_out.read(); //
              buf_rom_addr = i.read();
              state = buf_mult;
            }
            buf_ram_addr = buf_ram_addr.read(); // 
            next_state = write_state;
	    //prox_read = 0;
            if (i.read() != 35) i = i.read() + 1;
            else i = 0;
            break;
              
	case 2:       
            if (i.read() < 6) {
              data_out = 0;   
              buf_rom_addr = buf_rom_addr.read(); //
              buf_ram_addr = i.read();
              state = write_ram;
              next_state = write_state;
            }
            else if (i.read() >= 6 && i.read() < 12) {
              buf_rom_addr = i.read()-6+36;
              buf_ram_addr = i.read()-6;
              read_on_ram = 1;
              state = buf_mult;
              next_state = bt2_state;
            }
            else if (i.read() >= 12 && i.read() < 18) {
              data_out = data_out.read(); //
              buf_rom_addr = i.read()-12+36;
              buf_ram_addr = buf_ram_addr.read(); //
              read_on_ram = 0;
              state = buf_mult;
              next_state = bt2_state;
            }
            else if (i.read() >= 18 && i.read() < 24) {
              data_out = data_out.read(); // 
              buf_rom_addr = buf_rom_addr.read(); //
              buf_ram_addr = i.read()-18;
              wait = 1;
              state = write_ram;
              next_state = read_state;
            }
            else if (i.read() >= 24 && i.read() < 30) {
              data_out = data_out.read(); // 
              buf_rom_addr = i.read()-24+36;
              buf_ram_addr = buf_ram_addr.read(); //
              state = buf_mult; read_on_ram = 0;
              next_state = bt2_state;
            }
            else if (i.read() >= 30 && i.read() < 36) {
              data_out = data_out.read(); // 
              buf_rom_addr = i.read() - 24+36;//----------------------
              buf_ram_addr = buf_ram_addr.read(); //
              state = buf_mult;
              read_on_ram = 0;
              if (i.read() == 35) bt2 = 1;
              else bt2 = 0;
              next_state = write_state;
            }
            i = i.read() + 1;
            break;
        }
	in_ready = 0;
      }
      else {
         data_out = data_out.read(); //
         buf_rom_addr = buf_rom_addr.read(); //
         buf_ram_addr = buf_ram_addr.read(); //
         state = read_state;
         next_state = write_state; //
         i = i.read(); //
      }
      break;

    case buf_mult:
      // Enviando o endereço desejado para memoria
      out_trans = 0;
      in_ready = 0;
      buf_ram_we = 0;
      state = buf_mult_addr;
      break;


    case buf_mult_addr:
      // Lendo a memoria e preparando o dado a ser enviado
      out_trans = 0;
      in_ready = 0;
      buf_ram_we = 0;
      if (read_on_ram) mul_a = buf_ram_out.read();
      else mul_a = mul_a.read();
      mul_b = buf_rom_out.read();
      state = buf_mult_w;
      break;

    case buf_mult_w:
      // Lendo a memoria e preparando o dado a ser enviado
      out_trans = 0;
      in_ready = 0;
      buf_ram_we = 0;
      data_out = mul_c.read() + mul_c_ant.read();
      state = next_state;
      break;

    case write_state:
      in_ready = 0;
      buf_ram_we = 0;
      out_trans = 1;
        if (out_ready == 1) {
          if (bt2.read() == 1) state = bt2_state;
          else {
	    state = read_state;
	    in_ready = 1;
	  }
        }
        else {
	  state = write_state;
	}
      break;

    case write_ram:
      out_trans = 0;
      buf_ram_in = data_ant.read(); //////////
      buf_ram_we = 1;
      state = next_state;

      if (next_state.read() == read_state) in_ready = 1;
      else in_ready = 0;
      break;

    case bt2_state:
      buf_ram_we = 0;
      out_trans = 0;
      in_ready = 0;
      bt2 = 0;
      wait = 0;
      if(i.read() >= 7 && i.read() < 13){
        read_on_ram = 0;
        data_out = data_out.read(); //
        buf_rom_addr = buf_rom_addr.read(); //
        buf_ram_addr = i.read()-7;
        state = write_ram;
        next_state = write_state;
      }
      else if(i.read() >= 13 && i.read() < 19){
        buf_rom_addr = i.read()-7+36;
        buf_ram_addr = i.read()-13;
        read_on_ram = 1;
        mul_c_ant = mul_c;
        state = buf_mult;
        next_state = write_state;
      }
      else if(i.read() >= 25 && i.read() < 31){
        buf_rom_addr = i.read()-25+36+6;
        buf_ram_addr = i.read()-25;
        read_on_ram = 1;
        mul_c_ant = mul_c;
        state = buf_mult;
        next_state = write_state;
      }
      else if (i.read() >= 36 && i.read() < 43) {
        bt2 = 1;
        data_out = 0; 
        buf_rom_addr = buf_rom_addr.read(); // 
        buf_ram_addr = buf_ram_addr.read(); // 
        next_state = write_state; //
        if (i.read() != 42) {
          i = i.read() + 1;
          state = write_state;
        }
        else {
          i = 0;
	  in_ready = 1;
          state = read_state;
        }
      }
      break;

    default:
      in_ready = 0;
      out_trans = 0;

      buf_ram_we = 0;
      buf_ram_addr = 0;
      buf_ram_in = 0;
      buf_rom_addr = 0;
      mul_a = 0;
      mul_b = 0;

      read_on_ram = 0;
      data_ant = 0;
      i=0;
      data_out = 0;
      block_type = in_block_type.read();
      out_nch = in_nch.read();
      nch = in_nch.read();

      wait = 0;
      bt2 = 0;

      next_state = write_state;
      state = read_state;
      break;      
  }
}

