#include "overlap.h"

/*
  Faz a sobreposição (soma) da primeira metade dos sinais de um canal com a segunda metade do anterior
  
  Responsável : André Costa - andre.lnc@gmail.com
*/

void overlap::fsm(){
  
  
  if(reset_n==0){
    
    // Inicialização das variáveis
    in_ready = 0;
    out_trans = 0;

    buf_we = 0;
    buf_addr = 0;
    buf_in = 0;
    
    data_ant = 0;
    i=0;
    sb=0;
    ch=0;
    valid_ch=0;
    valid_sb=0;
    
    state = read_state;
  }
  else switch(state) {
    
  case read_state:
    buf_we = 0;
    out_trans=0;
    in_ready= 1; // Pronto para ler
    
    // Verifica se os dados de entrada são válidos
    if (in_trans.read() == 1) {
      
      // Primeira metade dos sinais (Leia e prepare para escrever na saída)
      if(i.read()<18){
	
	// Se já existir dados válidos no buffer, então faça a soma, senão apenas repasse os dados
	if((ch.read() < valid_ch.read()) && (sb.read() < valid_sb.read())) {
	  data_ant = data_in.read();
	  buf_addr = ((i.read())*32*2) + (ch.read()*32) + sb.read();
	  
	  if((sb.read() & 1) && (i.read() & 1)) inverte = 1;
	  else inverte = 0;
	  
	  state = write_state_addr;
	}
	else {
	  if((sb.read() & 1) && (i.read() & 1)) data_out = - data_in.read();
	  else  data_out = data_in.read();
	  
	  state = write_state;
	}
	
	// Leitura do numero de canais "in_nch" e repasse para saída
	if(i.read()==0 && sb.read()==0 && ch.read()==0) {
	  nch=in_nch.read();
	  out_nch=in_nch.read();
	}
	else {
	  out_nch=nch.read();
	  nch = nch.read();
	}
	
	// Atualiza os valores "i, sb, ch"
	if (i.read() != 35) i = i.read() + 1;
	else i = 0;
	if (i.read() == 35) {
	  if (sb.read() != 31) sb = sb.read() + 1;
	  else sb = 0;
	  if (sb.read() == 31) {
	    if (ch.read() != (nch.read() - 1)) ch = ch.read() + 1;
	    else ch = 0;
	  }
	}
	in_ready = 0;
      }
      else {
	
        // Segunda metade dos sinais (Leia e armazene no buffer)
	
	// Preparando para armazenar os dados no buffer
	data_out = 0;
	buf_addr = ((i.read()-18)*32*2) + (ch.read()*32) + sb.read();
	data_ant = data_in.read();
	in_ready = 0;
	
	state = read_state_addr;
	
	// Atualiza os valores "i, sb, ch, valid_sb, valid_ch"
	if (i.read() != 35) i = i.read() + 1;
	else {i = 0;
	a = a.read() +1;
	}
	if (i.read() == 35) {
	  if (sb.read() != 31) sb = sb.read() + 1;
	  else sb = 0;
	  if (valid_sb.read() != 32) valid_sb = valid_sb.read() + 1;
	  if (sb.read() == 31) {
	    
	    if (valid_ch.read() == 2 || (nch.read() == 2 && ch.read() == 1)) valid_ch = 2;
	    else valid_ch = 1;
	    
	    if (ch.read() != (nch.read() - 1)) ch = ch.read() + 1;
	    else ch = 0;
	    
	  }
	}
      }
      
    }
    else state = read_state;
    
    break;
    
  case read_state_addr:
    // Armazenando os dados no buffer
    out_trans = 0;
    in_ready = 1;
    buf_in = data_ant.read();
    buf_we = 1;
    state = read_state;
    break;
    
  case write_state_addr:
    // Enviando o endereço desejado para memoria
    out_trans = 0;
    in_ready = 0;
    buf_we = 0;
    state = write_state_addr_w;
    break;
    
  case write_state_addr_w:
    // Lendo a memoria e preparando o dado a ser enviado
    out_trans = 0;
    in_ready = 0;
    buf_we = 0;
    if (inverte.read()) data_out = - data_ant.read() - buf_out.read();
    else data_out = data_ant.read() + buf_out.read();
    state = write_state;
    break;
    
  case write_state:
    // Escrevendo na saída
    buf_we = 0;
    out_trans = 1;
    
    if (out_ready == 1) {
      state = read_state;
      in_ready = 1;
    }
    else {
      state = write_state;
      in_ready = 0;
    }
    break;
  }
}


